'
' A minimalistic SN dump player.

CON _clkmode = xtal1 + pll16x
    _xinfreq = 5_000_000
    
    sdPins   = 0
    rightPin = 10  
    leftPin  = 11
                       
VAR
  byte buffer[256]

OBJ
  SN : "SNcog"
  SD : "fsrw" 
                                                      
PUB Main | continue, i, waitFor
  sd.mount(sdPins)                     ' Mount SD card
  sd.popen(string("Sonic1.vgm"), "r")  ' Open tune

  SN.start(rightPin, leftPin)          ' Start SNcog

  '"Handle" vgm header
  sd.pread(@buffer, 64)
  if buffer[$34] <> 0 | buffer[$35] <> 0 | buffer[$36] <> 0 | buffer[$37] <> 0
    sd.pread(@buffer, 64)       

  waitFor := cnt + 10_000_000

  ' Loop for ever!!!
  repeat

    continue := true
    repeat while continue

      sd.pread(@buffer, 1)

      if buffer[0] == $50
        sd.pread(@buffer, 1)
        SN.setRegister(buffer[0])  
        
      elseif buffer[0] == $61
        sd.pread(@buffer, 2)
        waitFor := cnt + (constant(80_000_000/44100) * (buffer[0] | (buffer[1]<<8) ) ) 
        continue := false
        
      elseif buffer[0] == $62
        waitFor := cnt + constant(80_000_000/60)
        continue := false
        
      elseif buffer[0] == $63 
        waitFor := cnt + constant(80_000_000/50)
        continue := false
        
      elseif buffer[0] == $66
        continue := false

    waitcnt(waitFor)
    SN.flipRegisters
             